/******************************************************************************
 * Copyright (c) yvan vander sanden.												                  *
 * Header file to wrap FMOD sound library in Esenthel Engine                  *
/******************************************************************************/

// There is a global Fader object. It will fade all added sounds to an asked point.
// You should not need this object directly. It is called if you call 
// FM::Sound.fadexxx() functions.

#pragma once

namespace FM {

	struct FaderItem {
		Flt step	;
		Flt target;
		Flt Delete;
		FMOD::Channel * channel;
	};

	struct FaderControl {
		void add		(FMOD::Channel * channel, Flt time, Flt target, Bool deleteChannel = false); // add a sound to the fader system to fade it in or out. Time is in seconds, target 0..1, deleteChannel deletes channel pointer when done. (Best to use this only when target = 0 and sound is not needed any more.
		void remove	(FMOD::Channel * channel);
		void update	(												);
	private:
		Memc<FaderItem>			_faders;
	};
	
	extern FaderControl Fader;
}