#include "stdafx.h"
#include "FMOD.h"
#include "../data/enum/_enums.h"

FM::Reverb::Reverb() {
	_min_distance = 10;
	_max_distance = 20;
	_pos.zero();
}

void FM::Reverb::create(Byte type) {
	_type = type;
	FM::SoundSystem._createReverb(&_reverb);
	_setType();
	//FMOD_VECTOR pos = FM::vecToFmod(_pos);
	//_reverb->set3DAttributes(&pos, _min_distance, _max_distance);
	_reverb->setActive(true);
}

FM::Reverb& FM::Reverb::pos(C Vec &p) {
	_pos = p;
	FMOD_VECTOR pos = FM::vecToFmod(_pos);
	FMOD_RESULT result;
	result = _reverb->set3DAttributes(&pos, _min_distance, _max_distance);
	_reverb->setActive(true);
	return T;
}

Vec FM::Reverb::pos() {
	return _pos;
}

FM::Reverb& FM::Reverb::type(Byte t) {
	_type = t;
	_setType();
	return T;
}

Byte FM::Reverb::type() {
	return _type;
}

FM::Reverb& FM::Reverb::min(Flt distance) {
	_min_distance = distance;
	FMOD_VECTOR pos = FM::vecToFmod(_pos);
	_reverb->set3DAttributes(&pos, _min_distance, _max_distance);
	return T;
}

Flt FM::Reverb::min() {
	return _min_distance;
}

FM::Reverb& FM::Reverb::max(Flt distance) {
	_max_distance = distance;
	FMOD_VECTOR pos = FM::vecToFmod(_pos);
	_reverb->set3DAttributes(&pos, _min_distance, _max_distance);
	return T;
}

Flt FM::Reverb::max() {
	return _max_distance;
}

void FM::Reverb::_setType() {
	// these properties cannot be declared dynamically, it seems
switch(_type) {
		case OFF:								{
															FMOD_REVERB_PROPERTIES p	= FMOD_PRESET_OFF;
															_reverb->setProperties(&p);
															break;
														}
		case GENERIC:						{
															FMOD_REVERB_PROPERTIES p = FMOD_PRESET_GENERIC;
															_reverb->setProperties(&p);
															break;
														}
		case PADDEDCELL:				{
															FMOD_REVERB_PROPERTIES p	= FMOD_PRESET_PADDEDCELL;
															_reverb->setProperties(&p);
															break;
														}
		case ROOM: 							{
															FMOD_REVERB_PROPERTIES p	= FMOD_PRESET_ROOM;
															_reverb->setProperties(&p);
															break;
														}
		case BATHROOM:					{
															FMOD_REVERB_PROPERTIES p	= FMOD_PRESET_BATHROOM;
															_reverb->setProperties(&p);
															break;
														}
		case LIVINGROOM:				{
															FMOD_REVERB_PROPERTIES p	= FMOD_PRESET_LIVINGROOM;
															_reverb->setProperties(&p);
															break;
														}
		case STONEROOM:					{
															FMOD_REVERB_PROPERTIES p = FMOD_PRESET_STONEROOM;
															_reverb->setProperties(&p);
															break;
														}
		case AUDITORIUM:				{
															FMOD_REVERB_PROPERTIES p	= FMOD_PRESET_AUDITORIUM;
															_reverb->setProperties(&p);
															break;
														}
		case CONCERTHALL:				{
															FMOD_REVERB_PROPERTIES p = FMOD_PRESET_CONCERTHALL;
															_reverb->setProperties(&p);
															break;
														}
		case CAVE:							{
															FMOD_REVERB_PROPERTIES p = FMOD_PRESET_CAVE;
															_reverb->setProperties(&p);
															break;
														}
		case ARENA:							{
															FMOD_REVERB_PROPERTIES p = FMOD_PRESET_ARENA;
															_reverb->setProperties(&p);
															break;
														}
		case HANGAR:						{
															FMOD_REVERB_PROPERTIES p = FMOD_PRESET_HANGAR;
															_reverb->setProperties(&p);
															break;
														}
		case CARPETTEDHALLWAY:	{
															FMOD_REVERB_PROPERTIES p = FMOD_PRESET_CARPETTEDHALLWAY;
															_reverb->setProperties(&p);
															break;
														}
		case HALLWAY:						{
															FMOD_REVERB_PROPERTIES p = FMOD_PRESET_HALLWAY;
															_reverb->setProperties(&p);
															break;
														}
		case STONECORRIDOR:			{
															FMOD_REVERB_PROPERTIES p = FMOD_PRESET_STONECORRIDOR;
															_reverb->setProperties(&p);
															break;
														}
		case ALLEY:							{
															FMOD_REVERB_PROPERTIES p = FMOD_PRESET_ALLEY;
															_reverb->setProperties(&p);
															break;
														}
		case FOREST:						{
															FMOD_REVERB_PROPERTIES p	= FMOD_PRESET_FOREST;
															_reverb->setProperties(&p);
															break;
														}
		case CITY:							{
															FMOD_REVERB_PROPERTIES p = FMOD_PRESET_CITY;
															_reverb->setProperties(&p);
															break;
														}
		case MOUNTAINS:					{
															FMOD_REVERB_PROPERTIES p = FMOD_PRESET_MOUNTAINS;
															_reverb->setProperties(&p);
															break;
														}
		case QUARRY:						{
															FMOD_REVERB_PROPERTIES p = FMOD_PRESET_QUARRY;
															_reverb->setProperties(&p);
															break;
														}
		case PLAIN:							{
															FMOD_REVERB_PROPERTIES p = FMOD_PRESET_PLAIN;
															_reverb->setProperties(&p);
															break;
														}
		case PARKINGLOT:				{
															FMOD_REVERB_PROPERTIES p = FMOD_PRESET_PARKINGLOT;
															_reverb->setProperties(&p);
															break;
														}
		case SEWERPIPE:					{
															FMOD_REVERB_PROPERTIES p = FMOD_PRESET_SEWERPIPE;
															_reverb->setProperties(&p);
															break;
														}
		case UNDERWATER:				{
															FMOD_REVERB_PROPERTIES p = FMOD_PRESET_UNDERWATER;
															_reverb->setProperties(&p);
															break;
														}
		case DRUGGED:						{
															FMOD_REVERB_PROPERTIES p = FMOD_PRESET_CITY;
															_reverb->setProperties(&p);
															break;
														}
		case DIZZY:							{
															FMOD_REVERB_PROPERTIES p= FMOD_PRESET_CITY;
															_reverb->setProperties(&p);
															break;
														}
		case PSYCHOTIC:					{
															FMOD_REVERB_PROPERTIES p= FMOD_PRESET_CITY;
															_reverb->setProperties(&p);
															break;
														}
		case PS2_ROOM:					{
															FMOD_REVERB_PROPERTIES p= FMOD_PRESET_PSP_ROOM;
															_reverb->setProperties(&p);
															break;
														}
		case PS2_STUDIO_A:			{
															FMOD_REVERB_PROPERTIES p= FMOD_PRESET_PSP_STUDIO_A;
															_reverb->setProperties(&p);
															break;
														}
		case PS2_STUDIO_B:			{
															FMOD_REVERB_PROPERTIES p= FMOD_PRESET_PSP_STUDIO_B;
															_reverb->setProperties(&p);
															break;
														}
		case PS2_STUDIO_C:			{
															FMOD_REVERB_PROPERTIES p= FMOD_PRESET_PSP_STUDIO_C;
															_reverb->setProperties(&p);
															break;
														}
		case PS2_HALL:					{
															FMOD_REVERB_PROPERTIES p= FMOD_PRESET_PSP_HALL;
															_reverb->setProperties(&p);
															break;
														}
		case PS2_ECHO:					{
															FMOD_REVERB_PROPERTIES p= FMOD_PRESET_PSP_ECHO;
															_reverb->setProperties(&p);
															break;
														}
		case PS2_DELAY:					{
															FMOD_REVERB_PROPERTIES p= FMOD_PRESET_PSP_DELAY;
															_reverb->setProperties(&p);
															break;
														}
		case PS2_PIPE:					{
															FMOD_REVERB_PROPERTIES p= FMOD_PRESET_PSP_PIPE;
															_reverb->setProperties(&p);
															break;
														}
		}
	}

	void FM::Reverb::release() {
		_reverb->release();
	}
