/******************************************************************************
 * Copyright (c) yvan vander sanden.												                  *
 * Header file to wrap FMOD sound library in Esenthel Engine                  *
/******************************************************************************/

// reverb types are declared in reverb_type.enum.h
// Add it to your data enums and you can use them in the world editor
// and make enumerated reverb objects

#pragma once

namespace FM {
	struct Reverb {
		Reverb();
		void create(Byte type);
		void release();
		Reverb& pos(C Vec &p); Vec pos();
		Reverb& type(Byte t); Byte type();
		Reverb& min(Flt distance); Flt min();
		Reverb& max(Flt distance); Flt max();

	private:
		Byte _type;
		Vec _pos;
		Flt _min_distance;
		Flt _max_distance;
		FMOD::Reverb * _reverb;
		void _setType();
	};
}

