/******************************************************************************
 * Copyright (c) yvan vander sanden.												                  *
 * Header file to wrap FMOD sound library in Esenthel Engine                  *
/******************************************************************************/

/* dsp

*/
#pragma once
#include "dsp/dspElement.h"
#include "dsp/sample.h"

// add your dsp modules here
#include "dsp/modules/ringModulator.h"


// add define for faster access
#define AS_RINGMODULATOR(DspPatcher, element) (*(FM::DSP::ringModulator*)DspPatcher.dspElements[element])

namespace FM {
	
	namespace DSP {
		struct dspElmPtr {
			DSP::dspElement * data;
			Flt order;
		};
	}

	struct dsp {
		void create();
		void release();

		dsp& byPass(Bool bp);
		Bool byPass();
		
		DSP::samplePtr in, out;

		DSP::dspElmPtr * add(DSP::DSP_TYPE type, Flt order = 0);
		void remove(DSP::dspElmPtr * element);
		void sort();

		FMOD_DSP_DESCRIPTION description;
		FMOD::DSP *dspPtr;

		Memb<DSP::dspElmPtr> dspElements;		


		static FMOD_RESULT F_CALLBACK readCallback(FMOD_DSP_STATE * dsp_state, float *in, float *out, unsigned int length, int inchannels, int outchannels);

		
	};
}