#pragma once
#include "sample.h"

namespace FM {
	namespace DSP {

		struct filterKernel {
			Int filterpoints;
			Int hoppoints;
			Int skippoints;
			Int nhops;
			Flt centerFreq;
			Flt bandwitdth;
			Flt * stuff;
		};

		struct filterBank {
			Int nFilters;
			Int nPoints;
			Flt halfTones;
			Flt overlap;
			Flt firstBin;
			Flt minBandwidth;
			filterKernel * vec;
			Int refcount;
			struct filterBank * next;
		};

		#define MAXNFILTERS 50
		#define MASKHIST 8

		typedef struct hist {
			Flt power;
			Flt before;
			Flt outpower;
			Int countup;
			Flt mask[MASKHIST];
		} Hist;

		typedef struct bonkTemplate {
			Flt amp[MAXNFILTERS];
		} BonkTemplate;

		typedef struct inSig {
			Hist bonkHist[MAXNFILTERS];
			Flt * out;
			Flt * inBuffer;
			Flt * inVector;
		} InSig;

		struct bonk {
			Int npoints;
			Int period;
			Int nfilters;
			Flt halftones;
			Flt firstbin;
			Flt minBandwidth;
			Flt hithresh;
			Flt lothresh;
			Flt minVel;
			Int maskTime;
			Int useLoudness;
			Flt debouncedecay;
			Flt debouncevel;


		};

	}
}