#pragma once
#include "sample.h"

namespace FM {
	namespace DSP {

		struct clip {
			clip& set			(Flt low, Flt high) { T.low	= low;	T.high = high;	return T; }
			clip& setLow	(Flt low					) { T.low	= low;									return T; }
			clip& setHigh	(					Flt high) {								T.high = high;	return T; }
			
			samplePtr& operator()(samplePtr& in);
			clip() { low = -1; high = 1; }
		private:
			Flt low;
			Flt high;
			sample buffer;
		};

		// reciprocal square root good to 8 mantissa bits
		struct rSqrt {
			samplePtr& operator()(samplePtr& in);
			rSqrt();
		private:
			sample buffer;
		};

		// square root good to 8 mantissa bits
		struct sqrt {
			samplePtr& operator()(samplePtr& in);
			sqrt();
		private:
			sample buffer;
		};

		// calculates difference between signal and first exceeding integer
		struct wrap {
			samplePtr& operator()(samplePtr& in);
		private:
			sample buffer;
		};

		struct midiToFreq {
			samplePtr& operator()(samplePtr& in);
		private:
			sample buffer;
		};


		struct freqToMidi {
			samplePtr& operator()(samplePtr& in);
		private:
			sample buffer;
		};

		struct dbToRms {
			samplePtr& operator()(samplePtr& in);
		private:
			sample buffer;
		};

		struct rmsToDb {
			samplePtr& operator()(samplePtr& in);
		private:
			sample buffer;
		};

		struct dbToPow {
			samplePtr& operator()(samplePtr& in);
		private:
			sample buffer;
		};

		struct powToDb {
			samplePtr& operator()(samplePtr& in);
		private:
			sample buffer;
		};

		struct pow {
			samplePtr& operator()(samplePtr& in1, samplePtr& in2);
		private:
			sample buffer;
		};

		struct exp {
			samplePtr& operator()(samplePtr& in);
		private:
			sample buffer;
		};

		struct log {
			samplePtr& operator()(samplePtr& in1, samplePtr& in2);
		private:
			sample buffer;
		};

		struct abs {
			samplePtr& operator()(samplePtr& in);
		private:
			sample buffer;
		};
	}
}