#include "stdafx.h"
#include "ringModulator.h"

Meml<FM::DSP::ringModulator> FM::DSP::RingModulators;

FM::DSP::ringModulator::ringModulator() {
	type = DSP_RINGMODULATOR;
	frequency = 440;
	level = 0.5;
}

void FM::DSP::ringModulator::process(samplePtr& s) {
	// make a copy of the original, this will add the dry sound to the output
	extra.resize(s.getLength());
	extra = s;
	// adjust volume of dry sound
	extra *= (Flt)(1 - level);

	// generate sine wave at wanted frequency
	sin = sineGen(frequency, s.getLength());
	// combine input with sine to get a ring modulator effect
	s *= sin;
	// adjust volume of wet sound
	s *= level;

	// combine wet and dry sound 
	s += extra;
}