#pragma once
#include "../dspElement.h"
#include "../oscillators.h"

/*	when building a new dsp module, take this as an example.
		Also don't forget to:
		1. add a new type to DSP_TYPE in dspElement.h
		2. include your header file to dsp.h
		4. add code to add and remove functions in dsp.cpp
		5. add code to callback function in dsp.cpp
*/

namespace FM {
	namespace DSP {

		struct ringModulator : dspElement {
			ringModulator();
			void process(samplePtr& s);

			Flt frequency;
			Flt level;
			sine sineGen;
			samplePtr sin;
			sample extra;
		};


		extern Meml<ringModulator> RingModulators;

	}
}