#pragma once
#include "sample.h"

namespace FM {
	namespace DSP {

		struct saw {
			samplePtr& operator()(Flt frequency, UInt length);
			samplePtr& operator()(samplePtr& in);
			saw();

		private:
			Dbl phase;
			Flt conv;
			Flt frequency;
			sample buffer;

			Flt *inPtr;
			void calc(Bool useFrequency);
		};

		struct cosine {
			samplePtr& operator()(samplePtr& in);
			cosine();

		private:
			sample buffer;
		};

		struct sine {
			samplePtr& operator()(Flt frequency, UInt length);
			samplePtr& operator()(samplePtr& in);
			sine();

		private:
			sample buffer;
			Dbl phase;
			Flt conv;
			Flt frequency;

			Flt *inPtr;
			void calc(Bool useFrequency);
		};


		struct noise {
			samplePtr& operator()(UInt length);
			noise();

		private:
			sample buffer;
			Int value;
		};

		struct vcf {
			vcf& sharpness(Flt q);
			samplePtr& operator()(samplePtr& in, samplePtr& center, sample& out2);
			vcf();

		private:
			Flt re;
			Flt im;
			Flt q;
			Flt isr;
			sample buffer;
		};

	}
}