#include "stdafx.h"
#include "sample.h"

FM::DSP::samplePtr& FM::DSP::samplePtr::operator+=(Flt f) {
	UInt l = length;
	Flt * ptr = buffer;
	for (; l > 7; l -= 8, ptr += 8) {
		ptr[0] += f; ptr[1] += f; ptr[2] += f; ptr[3] += f;
		ptr[4] += f; ptr[5] += f; ptr[6] += f; ptr[7] += f;
	}
	while(l--) *ptr++ += f;
	return T;
}

FM::DSP::samplePtr& FM::DSP::samplePtr::operator+=(FM::DSP::samplePtr& s) {
	Flt l = length;
	Flt * ptr1 = buffer;
	Flt * ptr2 = s.buffer;
	for (; l > 7; l -= 8, ptr1 += 8, ptr2 += 8) {
		ptr1[0] += ptr2[0]; ptr1[1] += ptr2[1]; ptr1[2] += ptr2[2]; ptr1[3] += ptr2[3];
		ptr1[4] += ptr2[4]; ptr1[5] += ptr2[5]; ptr1[6] += ptr2[6]; ptr1[7] += ptr2[7];
	}
	while(l--) *ptr1++ += *ptr2++;
	return T;
}

FM::DSP::samplePtr& FM::DSP::samplePtr::operator-=(Flt f) {
	UInt l = length;
	Flt * ptr = buffer;
	for (; l > 7; l -= 8, ptr += 8) {
		ptr[0] -= f; ptr[1] -= f; ptr[2] -= f; ptr[3] -= f;
		ptr[4] -= f; ptr[5] -= f; ptr[6] -= f; ptr[7] -= f;
	}
	while(l--) *ptr++ -= f;
	return T;
}

FM::DSP::samplePtr& FM::DSP::samplePtr::operator-=(FM::DSP::samplePtr& s) {
	Flt l = length;
	Flt * ptr1 = buffer;
	Flt * ptr2 = s.buffer;
	for (; l > 7; l -= 8, ptr1 += 8, ptr2 += 8) {
		ptr1[0] -= ptr2[0]; ptr1[1] -= ptr2[1]; ptr1[2] -= ptr2[2]; ptr1[3] -= ptr2[3];
		ptr1[4] -= ptr2[4]; ptr1[5] -= ptr2[5]; ptr1[6] -= ptr2[6]; ptr1[7] -= ptr2[7];
	}
	while(l--) *ptr1++ -= *ptr2++;
	return T;
}

FM::DSP::samplePtr& FM::DSP::samplePtr::operator*=(Flt f) {
	UInt l = length;
	Flt * ptr = buffer;
	for (; l > 7; l -= 8, ptr += 8) {
		ptr[0] *= f; ptr[1] *= f; ptr[2] *= f; ptr[3] *= f;
		ptr[4] *= f; ptr[5] *= f; ptr[6] *= f; ptr[7] *= f;
	}
	while(l--) *ptr++ *= f;
	return T;
}

FM::DSP::samplePtr& FM::DSP::samplePtr::operator*=(FM::DSP::samplePtr& s) {
	Flt l = length;
	Flt * ptr1 = buffer;
	Flt * ptr2 = s.buffer;
	for (; l > 7; l -= 8, ptr1 += 8, ptr2 += 8) {
		ptr1[0] *= ptr2[0]; ptr1[1] *= ptr2[1]; ptr1[2] *= ptr2[2]; ptr1[3] *= ptr2[3];
		ptr1[4] *= ptr2[4]; ptr1[5] *= ptr2[5]; ptr1[6] *= ptr2[6]; ptr1[7] *= ptr2[7];
	}
	while(l--) *ptr1++ *= *ptr2++;
	return T;
}

FM::DSP::samplePtr& FM::DSP::samplePtr::operator/=(Flt f) {
	UInt l = length;
	Flt * ptr = buffer;
	for (; l > 7; l -= 8, ptr += 8) {
		ptr[0] = (f? ptr[0] /= f : 0); 
		ptr[1] = (f? ptr[1] /= f : 0); 
		ptr[2] = (f? ptr[2] /= f : 0); 
		ptr[3] = (f? ptr[3] /= f : 0);
		ptr[4] = (f? ptr[4] /= f : 0); 
		ptr[5] = (f? ptr[5] /= f : 0); 
		ptr[6] = (f? ptr[6] /= f : 0); 
		ptr[7] = (f? ptr[7] /= f : 0);
	}
	while(l--) *ptr++ = (f? *ptr / f : 0);
	return T;
}

FM::DSP::samplePtr& FM::DSP::samplePtr::operator/=(FM::DSP::samplePtr& s) {
	Flt l = length;
	Flt * ptr1 = buffer;
	Flt * ptr2 = s.buffer;
	for (; l > 7; l -= 8, ptr1 += 8, ptr2 += 8) {
		ptr1[0] = (ptr2[0]? ptr1[0] /= ptr2[0] : 0); 
		ptr1[1] = (ptr2[1]? ptr1[1] /= ptr2[1] : 0); 
		ptr1[2] = (ptr2[2]? ptr1[2] /= ptr2[2] : 0); 
		ptr1[3] = (ptr2[3]? ptr1[3] /= ptr2[3] : 0);
		ptr1[4] = (ptr2[4]? ptr1[4] /= ptr2[4] : 0); 
		ptr1[5] = (ptr2[5]? ptr1[5] /= ptr2[5] : 0); 
		ptr1[6] = (ptr2[6]? ptr1[6] /= ptr2[6] : 0); 
		ptr1[7] = (ptr2[7]? ptr1[7] /= ptr2[7] : 0);
	
	}
	while(l--) {
		*ptr1 = (*ptr2? *ptr1 / *ptr2 : 0);
		ptr1++, ptr2++;
	}
	return T;
}

FM::DSP::samplePtr& FM::DSP::samplePtr::operator=(FM::DSP::samplePtr& s) {
	length = s.length;
	buffer = s.buffer;

	return T;
}

FM::DSP::samplePtr& FM::DSP::samplePtr::operator=(Flt f) {

	Flt l = length;
	Flt * ptr1 = buffer;
	for (; l > 7; l -= 8, ptr1 += 8) {
		ptr1[0] = f; 
		ptr1[1] = f; 
		ptr1[2] = f; 
		ptr1[3] = f;
		ptr1[4] = f; 
		ptr1[5] = f; 
		ptr1[6] = f; 
		ptr1[7] = f;
	
	}
	while(l--) *ptr1++ = f;

	return T;
}

FM::DSP::samplePtr& FM::DSP::samplePtr::copy(FM::DSP::samplePtr& s) {
	if (length != s.length) return T;

	Flt l = length;
	Flt * ptr1 = buffer;
	Flt * ptr2 = s.buffer;
	for (; l > 7; l -= 8, ptr1 += 8, ptr2 += 8) {
		ptr1[0] = ptr2[0]; 
		ptr1[1] = ptr2[1]; 
		ptr1[2] = ptr2[2]; 
		ptr1[3] = ptr2[3];
		ptr1[4] = ptr2[4]; 
		ptr1[5] = ptr2[5]; 
		ptr1[6] = ptr2[6]; 
		ptr1[7] = ptr2[7];
	
	}
	while(l--) *ptr1++ = *ptr2++;

	return T;
}

FM::DSP::sample& FM::DSP::sample::operator=(FM::DSP::samplePtr& s) {
	Flt l = length;
	Flt * ptr1 = buffer;
	Flt * ptr2 = s.getBuffer();
	for (; l > 7; l -= 8, ptr1 += 8, ptr2 += 8) {
		ptr1[0] = ptr2[0]; 
		ptr1[1] = ptr2[1]; 
		ptr1[2] = ptr2[2]; 
		ptr1[3] = ptr2[3];
		ptr1[4] = ptr2[4]; 
		ptr1[5] = ptr2[5]; 
		ptr1[6] = ptr2[6]; 
		ptr1[7] = ptr2[7];
	
	}
	while(l--) *ptr1++ = *ptr2++;

	return T;
}

void FM::DSP::sample::resize(UInt length) {
	ReallocZero(buffer, length, T.length);
	T.length = length;
}