#pragma once

namespace FM {
	namespace DSP {

		extern Int sampleRate;

		struct samplePtr {
		public:
			samplePtr							(																 ) { T.length = 0			;										 }
			samplePtr							(Flt * buffer, const UInt &length) { T.length = length; T.buffer = buffer; }
			samplePtr& operator()	(Flt * buffer, const UInt &length) { T.length = length; T.buffer = buffer; return T; }
			UInt  getLength() { return length; } 
			Flt * getBuffer() { return buffer; }

			samplePtr& operator+=(Flt f);
			samplePtr& operator-=(Flt f);
			samplePtr& operator*=(Flt f);
			samplePtr& operator/=(Flt f);

			samplePtr& operator+=(samplePtr& s);
			samplePtr& operator-=(samplePtr& s);
			samplePtr& operator*=(samplePtr& s);
			samplePtr& operator/=(samplePtr& s);

			samplePtr& operator=(samplePtr& s);
			samplePtr& operator=(Flt f);
			samplePtr& copy(samplePtr& s);
		protected:
			UInt length;
			Flt * buffer;
		};

		struct sample : samplePtr {
			sample() { buffer = Alloc<Flt>(64); length = 64; }
		 ~sample() { Free(buffer); }

			void resize(UInt length); // grow sample buffer to this length

			sample& operator=(samplePtr& s);
			sample& operator=(Flt f) { super::operator=(f); return T;}
		};


	}
}

