#include "stdafx.h"
#include "filesystem.h"

FMOD_RESULT F_CALLBACK FM::eeOpen(const char *name, int unicode, unsigned int *filesize, void **handle, void **userdata) {
	if (name) {
		File * f = new File;
		if (!f->readTry(name)) {
			delete f;
			return FMOD_ERR_FILE_NOTFOUND;
		}
		*filesize = f->size();
		*userdata = (void *)0x12345678;
		*handle = f;
	}

	return FMOD_OK;
}

FMOD_RESULT F_CALLBACK FM::eeClose(void *handle, void *userdata) {
	if (!handle)  return FMOD_ERR_INVALID_PARAM;

	delete handle;
	return FMOD_OK;
}

FMOD_RESULT F_CALLBACK FM::eeRead(void *handle, void *buffer, unsigned int sizebytes, unsigned int *bytesread, void *userdata) {
	if (!handle)  return FMOD_ERR_INVALID_PARAM;

	if (bytesread) {
		if (((File *)handle)->left() < *bytesread) sizebytes = *bytesread = ((File *)handle)->left();
		else *bytesread = sizebytes;

		((File *)handle)->get(buffer, sizebytes);

		if (((File *)handle)->end()) return FMOD_ERR_FILE_EOF;
	}

	return FMOD_OK;
}

FMOD_RESULT F_CALLBACK FM::eeSeek(void *handle, unsigned int pos, void *userdata) {
	if (!handle)  return FMOD_ERR_INVALID_PARAM;

	((File *)handle)->pos(pos);
	return FMOD_OK;
}
	

