/******************************************************************************/
#include "stdafx.h"
#include "../FMOD/FMOD.h" // Don't forget this one if you want FMOD sound

// this tutorial is esenthel's basic audio tutorial, adjusted for 
// use with FMOD.

// All structs and premade objects for FMOD are in the namespace FM.

/******************************************************************************/
// music themes, each for storing tracks
FM::MusicTheme	mt_battle , // this is battle theme used for playing when battles
					      mt_explore, // exploring theme
								mt_calm   ; // calm theme
/******************************************************************************/

Str resultTxt;
void InitPre()
{
   App.name("Music");
   App.flag=APP_NO_FX;
   DataPath("../data");
   Paks.add("engine.pak");

	 // you WILL need to create the soundsystem
	 FM::SoundSystem.create();
}
/******************************************************************************/
Bool Init()
{
   DefaultTextStyle.color =BLACK;
   DefaultTextStyle.shadow=0;
   if(!mt_battle.songs()) // create 'mt_battle' theme if not yet created
   {
			mt_battle+="music/battle0.ogg"; // add "battle0.ogg" track to 'mt_battle' theme
			mt_battle+="music/battle1.ogg"; // add "battle1.ogg" track to 'mt_battle' theme
	 }
   if(!mt_explore.songs()) // create 'mt_explore' theme if not yet created
   {
      mt_explore+="music/explore.ogg"; // add "explore.ogg" track to 'mt_explore' theme
   }
   if(!mt_calm.songs()) // create 'mt_calm' theme if not yet created
   {
      mt_calm+="music/calm.ogg"; // add "calm.ogg" track to 'mt_calm' theme
   }
   return true;
}
/******************************************************************************/
void Shut()
{
}
/******************************************************************************/
Bool Update()
{
   if(Kb.bp(KB_ESC))return false;
   if(Kb.c('1'))FM::Music.play(mt_battle );
   if(Kb.c('2'))FM::Music.play(mt_explore);
   if(Kb.c('3'))FM::Music.play(mt_calm   );
   if(Kb.c('4'))FM::Music.play(NULL      );

	 // every update needs to update the soundsystem!
	 FM::SoundSystem.update();
   return true;
}
/******************************************************************************/
void Draw()
{
   D.clear(WHITE);

   if(FM::Music.theme()) // if any theme playing
   {
      D.text(0,0.2f,S+"song: "+FM::Music.name());
      D.text(0,0.0f,S+"time " +FM::Music.time()+" / "+FM::Music.length()+" length");
   }else
   {
      D.text(0,0,"No theme playing");
   }

	 D.text(0,-0.2f,"Press 1-battle, 2-explore, 3-calm, 4-none");
}
/******************************************************************************/

