/******************************************************************************/
#include "stdafx.h"
#include "../FMOD/FMOD.h"

/******************************************************************************/
FM::Sound sound;      // sound
Vec   pos(0,0,3); // sound position
/******************************************************************************/
void InitPre()
{
   App.name("Sound 3D");
   App.flag=APP_NO_FX|APP_MS_EXCLUSIVE;
	 DataPath("../data");
   Paks.add("engine.pak");
	 FM::SoundSystem.create();
}
/******************************************************************************/
Bool Init()
{
   sound.play("sound/water.ogg",pos,1,true); // load looped 3D sound, volume=1, position='pos'
   return true;
}
/******************************************************************************/
void Shut()
{
}
/******************************************************************************/
Bool Update()
{
   if(Kb.bp(KB_ESC))return false;
   CamHandle(0.1f,10,CAMH_ZOOM|CAMH_ROT);

   // update all 3D sound positions
   {
      sound.pos(pos); // since 'pos' is the same in each frame, the sound position doesn't need to be updated, but let's do it anyway
   }

   // update listener parameters
   {
      FM::Listener.orn(Cam.matrix.z,Cam.matrix.y)  // set listener orientation (from camera)
									.pos(Cam.matrix.pos           ); // set listener position    (from camera)
   }
	 FM::SoundSystem.update();
   return true;
}
/******************************************************************************/
void Draw()
{
   D.clear(WHITE);

   SetMatrix();
   Ball(1,pos).draw(BLACK); // draw ball at sound position
}
/******************************************************************************/
