/******************************************************************************/
#include "stdafx.h"
#include "FMOD.h"
/******************************************************************************/
FM::MusicTheme	mt_battle  , // music themes
						    mt_explore ;
FM::Sound				sound      ; // sound
Slider					vol_fx     , // volume bars
								vol_music  ,
								vol_ambient; 
Text						tvol_fx     , // volume text
								tvol_music  ,
								tvol_ambient,
								tdepth			,  // for underwater effect
								tdepth2     ,
								tunderwater ;
Slider					depth				;
CheckBox				underwater	; 
/******************************************************************************/
void InitPre()
{
   App.name("Volume groups");
   App.flag=APP_NO_FX;
	 DataPath("../data");
   Paks.add("engine.pak");
	 FM::SoundSystem.create();
}
/******************************************************************************/
Bool Init()
{
   Gui.ts_text.scale*=1.5f; // make all Text objects bigger

   if(!mt_battle.songs()) // create mt_battle theme
   {
      mt_battle+="music/battle0.ogg"; // add "battle0.ogg" track to 'mt_battle' theme
      mt_battle+="music/battle1.ogg"; // add "battle0.ogg" track to 'mt_battle' theme
   }
   if(!mt_explore.songs()) // create mt_explore theme
   {
      mt_explore+="music/explore.ogg"; // add "explore.ogg" track to 'mt_explore' theme
   }
   
   FM::Music  .play(mt_battle ); // play theme as music
   FM::Ambient.play(mt_explore); // play theme as ambient
   sound			.play("sound/water.ogg",true); // play looped sound

   // create gui sliders
	 Gui+=vol_fx     .create(Rect(-0.1f, 0.30f, 0.3f, 0.40f), FM::ChannelFX			.volume()); Gui+=tvol_fx			.create(Vec2(-0.3f, 0.35f), "Fx"     );
   Gui+=vol_music  .create(Rect(-0.1f, 0.15f, 0.3f, 0.25f), FM::ChannelMusic	.volume()); Gui+=tvol_music		.create(Vec2(-0.3f, 0.20f), "Music"  );
   Gui+=vol_ambient.create(Rect(-0.1f, 0.00f, 0.3f, 0.10f), FM::ChannelAmbient.volume()); Gui+=tvol_ambient	.create(Vec2(-0.3f, 0.05f), "Ambient");
	 
	 // slider for depth
	 Gui+=depth  .create(Rect(-0.1f, -0.15f, 0.3f, -0.05f),       0);
	 Gui+=tdepth .create(Vec2(-0.5f, -0.10f              ), "Depth");
	 Gui+=tdepth2.create(Vec2(-0.3f, -0.10f              ), "0"    );

	 // underwater checkbox
	 Gui+=tunderwater.create(Vec2(-0.3f, -0.25f), "Underwater");
	 Gui+=underwater.create(Rect(-0.1f, -0.30f, 0.0f, -0.20f), false);

   return true;
}
/******************************************************************************/
void Shut()
{
}
/******************************************************************************/
Bool Update()
{
   if(Kb.bp(KB_ESC))return false;
   Gui.update();

   // set new volumes
	 FM::ChannelFX.volume(vol_fx());
	 FM::ChannelMusic.volume(vol_music());
   FM::ChannelAmbient.volume(vol_ambient());

	 // set underwater effect
	 Flt tmp = (depth() * 20);
	 FM::SoundSystem.underwater(underwater(), tmp);
	 tdepth2.set(S + tmp);

	 FM::SoundSystem.update();
   return true;
}
/******************************************************************************/
void Draw()
{
   D  .clear(WHITE);
   Gui.draw ();
}
/******************************************************************************/
