/******************************************************************************/
#include "stdafx.h"
#include "../FMOD/FMOD.h"

/******************************************************************************/
FM::Sound stream;
Vec pos (0,0,3);
Bool started = false;
/******************************************************************************/
void InitPre()
{
   App.name("Stream");
   App.flag=APP_NO_FX;
	 DataPath("../data");
   Paks.add("engine.pak");
	 FM::SoundSystem.create();
}
/******************************************************************************/
Bool Init()
{
   /* FMOD is able to stream files from the internet, BUT...
      This wrapper overwrites to FMOD file callbacks to be able to use
      EE's pak files. So in order to read network streams, you would either 
      a. disable the custom callbacks in filesystem.h
      b. extend those callbacks so that reading from the network is also
         possible. This would be the best option, but currently I have no
         time to implement this.
   */
   //stream.create("http://www.youngmusic.org/downloads/audio/2010/hyperfolly.mp3", false, 1.0f, FM::ChannelMusic(), true);
   stream.create("music/battle0.ogg", false, 1.0f, FM::ChannelMusic(), true);
   
   stream.play();
	 return true;
}
/******************************************************************************/
void Shut()
{
}
/******************************************************************************/
Bool Update()
{

	if(Kb.bp(KB_ESC))return false;
  CamHandle(0.1f,10,CAMH_ZOOM|CAMH_ROT);

	// sound control
	if (Kb.bp(KB_SPACE)) {
		if (stream.playing()) stream.pause();
		else stream.play();
	}
	if (Kb.bp(KB_P)) {
		if (stream.playing()) stream.stop();
		else stream.play();
	}


  // update all 3D sound positions
  {
    stream.pos(pos); // since 'pos' is the same in each frame, the sound position doesn't need to be updated, but let's do it anyway
  }

  // update listener parameters
  {
    FM::Listener.orn(Cam.matrix.z,Cam.matrix.y)  // set listener orientation (from camera)
								.pos(Cam.matrix.pos           ); // set listener position    (from camera)
  }
	FM::SoundSystem.update();
  return true;
}
/******************************************************************************/
void Draw()
{
   D.clear(WHITE);

	 if (stream.playing()) {
		 D.text(Vec2(0, -0.8), S + "playing");
	 }
	 Str txt = S + "Buffer is " + stream.bufferFilled() + " % full. ";
	 if (stream.starving()) txt += " But starving!";
	 D.text(Vec2(0, -0.9), txt);
	 SetMatrix();
	 Ball(1, pos).draw(BLACK);
}
/******************************************************************************/
