#include "stdafx.h"
#include "../FMOD/FMOD.h"

FM::Sound sound;
FM::dsp fx;
FM::DSP::dspElmPtr * ring;

Slider freqSlider;
Slider gainSlider;

void InitPre() {
  App.name("DSP");
  App.flag=APP_NO_FX;
	DataPath("../data");
  Paks.add("engine.pak");
	FM::SoundSystem.create();
}

Bool Init() {
	sound.create("music/calm.ogg", true, 1.0f, NULL, false, true);

	fx.create();
	sound.addDSP(fx);
	ring = fx.add(FM::DSP::DSP_RINGMODULATOR);
	((FM::DSP::ringModulator*)(ring->data))->frequency = 440;
	((FM::DSP::ringModulator*)(ring->data))->level = 0.5;
	sound.play();

	Gui += freqSlider.create(Rect(-0.3f,0.8f,0.3f,0.9f)); 
	Gui += gainSlider.create(Rect(-0.3f,0.6f,0.3f,0.7f));

	return true;
}

void Shut() {
}

Bool Update() {
	if(Kb.bp(KB_ESC))return false;
	Gui.update();

	FM::SoundSystem.lockDSP();
	((FM::DSP::ringModulator*)(ring->data))->frequency = freqSlider() * 2000;
	((FM::DSP::ringModulator*)(ring->data))->level = gainSlider();
	FM::SoundSystem.unlockDSP();

	FM::SoundSystem.update();
	return true;
}

void Draw() {
	D.clear(WHITE);
	Gui.draw();
}